"""
Django settings for ubitquity project.

Generated by 'django-admin startproject' using Django 2.0.4.

For more information on this file, see
https://docs.djangoproject.com/en/2.0/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.0/ref/settings/
"""

import os

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.0/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = '2bd-i9tl$z$kv$86o@w9q!(r_xv8scmbv^&%0tmo=&5&#qi2rk'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = os.environ.get('DEBUG', False)

ALLOWED_HOSTS = os.environ.get('ALLOWED_HOSTS', '').split(',')


# Application definition

INSTALLED_APPS = [
    'ubitquity',  
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.staticfiles',
    'rest_framework',
    'phonenumber_field',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'ubitquity.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
            ],
        },
    },
]

WSGI_APPLICATION = 'ubitquity.wsgi.application'


# Database
# https://docs.djangoproject.com/en/2.0/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': 'ubitquity.db',
    }
}

# Password validation
# https://docs.djangoproject.com/en/2.0/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = []


# Internationalization
# https://docs.djangoproject.com/en/2.0/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/2.0/howto/static-files/

STATIC_URL = '/static/'

# Document storage. Change the UBITQUITY_HOST to your IP address. Change UBITQUITY_FILE_PATH to your organization's server path.
MEDIA_URL = '/media/'
MEDIA_ROOT = 'media'

STATIC_ROOT = '/static/'

UBITQUITY_HOST = os.getenv('UBITQUITY_HOST', '45.32.1.3')
UBITQUITY_FILE_PATH = os.getenv('UBITQUITY_FILE_PATH', '/var/www/html/unanimity/folder')

# Blockchain-related config

INFURA_URL = os.getenv('INFURA_URL')
KEYFILE = os.getenv('KEYFILE')
PASSWORD = os.getenv('PASSWORD')
CHAIN_ID = int(os.getenv('CHAIN_ID', 4))
ACCOUNT = os.getenv('ACCOUNT')

# Ubitquity ssh related settings

SSH_USERNAME = os.getenv('SSH_USERNAME')
SSH_PASSWORD = os.getenv('SSH_PASSWORD')
SSH_ENABLED = os.getenv('SSH_ENABLED', False)  # default to false

REST_FRAMEWORK = {
    'DEFAULT_AUTHENTICATION_CLASSES': ()
}
